import java.util.Hashtable;
import java.util.Vector;
import javax.swing.table.*;

public class ServerTableModel extends RefreshAbstractTableModel
{

	Hashtable serverInfos;
	String columns[]={"Number","Host","Users","Files","Connected"};
	DonkeyCore donkeyCore;
	
	public ServerTableModel(Hashtable serverInfos,DonkeyCore donkeyCore)
	{
		this.donkeyCore=donkeyCore;
		this.serverInfos=serverInfos;
	}
	
	public int getColumnCount()
	{
		return columns.length;
	}
	
	public String getColumnName(int col)
	{
		return columns[col];
	}

	public int getRowCount()
	{
		return serverInfos.size();
	}
	
	public Object getValueAt(int row,int col)
	{
		if (col==0) return serverInfos.keySet().toArray()[row];
		return ((Vector)serverInfos.values().toArray()[row]).get(col-1);
	}

	public boolean isCellEditable(int row,int col)
	{
		return col==columns.length-1;
	}
	
	public void setValueAt(Object o,int row,int col)
	{
		Long id=(Long)getValueAt(row,0);
		Vector serverInfo=(Vector)serverInfos.get(id);
		if (((Boolean)serverInfo.elementAt(3)).booleanValue())
		{
			//((Vector)searchResult.get(row)).setElementAt(new Boolean(true),col);
			donkeyCore.disconnectServer((Long)getValueAt(row,0));
		}
		else
		{
			donkeyCore.connectServer((Long)getValueAt(row,0));
		}
	}

}